SystemOrganization addCategory: #'Cutie-Helvetia-Trans'!

!BlockContext methodsFor: '*cutie-helvetia-trans' stamp: 'lr 2/23/2009 13:54'!
atomic
	^ CUTransaction new atomic: self! !

QQTestCase subclass: #CUTransactionTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Trans'!

!CUTransactionTest class methodsFor: 'testing' stamp: 'lr 2/23/2009 11:13'!
isAbstract
	^ self name = #CUTransactionalTest! !

!CUTransactionTest class methodsFor: 'compiler' stamp: 'lr 9/2/2010 13:59'!
transform
	<annotator>

	^ Array
		with: (CHTreePattern new
			expression: '`var := `@expression' do: [ :context |
				context scopedTree variable hasVariableBinding ifTrue: [
					| binding |
					binding := context scopedTree variable variableBinding.
					binding isInstanceBinding ifTrue: [
						context scopedTree swapWith: ``(self
							atomicInstVarAt: `,(binding index)
							put: `,(context scopedTree value)) ] ] ])
		with: (CHTreePattern new
			expression: '`var' do: [ :context |
				context scopedTree hasVariableBinding ifTrue: [
					| binding |
					binding := context scopedTree variableBinding.
					binding isInstanceBinding ifTrue: [
						context scopedTree swapWith: ``(self
							atomicInstVarAt: `,(binding index)) ] ] ])! !

!CUTransactionTest methodsFor: 'utilities' stamp: 'lr 2/23/2009 15:48'!
abort: anObject
	self transaction abort: anObject! !

!CUTransactionTest methodsFor: 'private' stamp: 'lr 2/23/2009 15:55'!
atomicInstVarAt: anInteger
	^ self workingCopy instVarAt: anInteger! !

!CUTransactionTest methodsFor: 'private' stamp: 'lr 2/23/2009 15:55'!
atomicInstVarAt: anInteger put: anObject
	^ self workingCopy instVarAt: anInteger put: anObject! !

!CUTransactionTest methodsFor: 'utilities' stamp: 'lr 2/23/2009 15:48'!
checkpoint
	self transaction checkpoint! !

!CUTransactionTest methodsFor: 'testing-custom' stamp: 'lr 2/23/2009 16:33'!
conflict
	self transaction 
		addChange: (CUCustomChange 
			onApply: [ value := true ]
			onConflictTest: [ true ])! !

!CUTransactionTest methodsFor: 'testing-custom' stamp: 'lr 2/23/2009 16:33'!
sideeffect
	self transaction 
		addChange: (CUCustomChange
			onApply: [ value := true ])! !

!CUTransactionTest methodsFor: 'testing-abort' stamp: 'lr 2/23/2009 16:31'!
testAbortAccessor
	self assert: [ self value: true; abort: self value ] atomic.
	self assert: self value isNil! !

!CUTransactionTest methodsFor: 'testing-abort' stamp: 'lr 2/23/2009 16:31'!
testAbortInstance
	self assert: [ value := true. self abort: value ] atomic.
	self assert: value isNil! !

!CUTransactionTest methodsFor: 'testing-abort' stamp: 'lr 2/23/2009 16:31'!
testAbortTemp
	| temp |
	self assert: [ temp := true. self abort: temp ] atomic.
	self assert: temp! !

!CUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testAccessor
	self assert: [ self value: true. self value ] atomic! !

!CUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testAccessorRead
	self value: true.
	self assert: [ self value ] atomic! !

!CUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testAccessorWrite
	[ self value: true ] atomic.
	self assert: self value! !

!CUTransactionTest methodsFor: 'testing' stamp: 'lr 2/23/2009 16:31'!
testBasicContext
	self assert: [ thisContext home ] atomic == thisContext! !

!CUTransactionTest methodsFor: 'testing' stamp: 'lr 2/23/2009 16:31'!
testBasicSelf
	self assert: [ self ] atomic == self! !

!CUTransactionTest methodsFor: 'testing' stamp: 'lr 2/23/2009 16:31'!
testBasicSuper
	self assert: [ super ] atomic == self! !

!CUTransactionTest methodsFor: 'testing-check' stamp: 'lr 2/23/2009 16:31'!
testCheckAccessor
	self assert: [ self value: true; checkpoint; abort: self value ] atomic.
	self assert: self value! !

!CUTransactionTest methodsFor: 'testing-check' stamp: 'lr 2/23/2009 16:31'!
testCheckInstance
	self assert: [ value := true. self checkpoint. self abort: value ] atomic.
	self assert: value! !

!CUTransactionTest methodsFor: 'testing-check' stamp: 'lr 2/23/2009 16:31'!
testCheckTemp
	| temp |
	self assert: [ temp := true. self checkpoint. self abort: temp ] atomic.
	self assert: temp! !

!CUTransactionTest methodsFor: 'testing-custom' stamp: 'lr 2/23/2009 16:43'!
testConflict
	self 
		should: [ [ self conflict ] atomic ]
		raise: CUTransactionConflict.
	self assert: value isNil! !

!CUTransactionTest methodsFor: 'testing-error' stamp: 'lr 2/23/2009 16:31'!
testErrorAccessor
	self 
		should: [ [ self value: true. self assert: self value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: value isNil! !

!CUTransactionTest methodsFor: 'testing-error' stamp: 'lr 2/23/2009 16:31'!
testErrorInstance
	self 
		should: [ [ value := true. self assert: value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: value isNil! !

!CUTransactionTest methodsFor: 'testing-error' stamp: 'lr 2/23/2009 16:31'!
testErrorTemp
	| temp |
	self 
		should: [ [ temp := true. self assert: temp. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: temp! !

!CUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testInstance
	self assert: [ value := true. value ] atomic! !

!CUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testInstanceRead
	value := true.
	self assert: [ value ] atomic! !

!CUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testInstanceWrite
	[ value := true ] atomic.
	self assert: value! !

!CUTransactionTest methodsFor: 'testing-custom' stamp: 'lr 2/23/2009 16:31'!
testSideeffect
	[ self sideeffect ] atomic.
	self assert: value! !

!CUTransactionTest methodsFor: 'utilities' stamp: 'lr 2/23/2009 16:42'!
transaction
	^ CUTransactionCurrent signal! !

!CUTransactionTest methodsFor: 'accessing' stamp: 'lr 2/23/2009 15:48'!
value
	^ value! !

!CUTransactionTest methodsFor: 'accessing' stamp: 'lr 2/23/2009 15:47'!
value: anObject
	value := anObject! !

!CUTransactionTest methodsFor: 'private' stamp: 'lr 2/23/2009 16:43'!
workingCopy
	"Answer a working copy to be used within the context of the current transaction."
	
	| transaction |
	transaction := self transaction
		ifNil: [ ^ self ].
	^ (transaction changeFor: self) 
		working! !

Notification subclass: #CUTransactionCurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Trans'!

!BlockClosure methodsFor: '*cutie-helvetia-trans' stamp: 'lr 5/18/2009 15:02'!
atomic
	^ CUTransaction new atomic: self! !

Object subclass: #CUChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Trans'!

!CUChange methodsFor: 'actions' stamp: 'lr 6/8/2007 16:59'!
apply
	self subclassResponsibility! !

!CUChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:00'!
hasChanged
	^ true! !

!CUChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:00'!
hasConflict
	^ false! !

CUChange subclass: #CUCustomChange
	instanceVariableNames: 'applyBlock conflictTestBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Trans'!

!CUCustomChange class methodsFor: 'instance creation' stamp: 'lr 2/26/2008 16:15'!
onApply: anApplyBlock
	^ self onApply: anApplyBlock onConflictTest: [ false ]! !

!CUCustomChange class methodsFor: 'instance creation' stamp: 'lr 6/8/2007 17:03'!
onApply: anApplyBlock onConflictTest: aConflictTestBlock
	^ self basicNew initializeApply: anApplyBlock conflictTest: aConflictTestBlock! !

!CUCustomChange methodsFor: 'actions' stamp: 'lr 2/26/2008 16:26'!
apply
	applyBlock value! !

!CUCustomChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:28'!
hasConflict
	^ conflictTestBlock value! !

!CUCustomChange methodsFor: 'initialization' stamp: 'lr 6/8/2007 17:04'!
initializeApply: anApplyBlock conflictTest: aConflictTestBlock	
	applyBlock := anApplyBlock.
	conflictTestBlock := aConflictTestBlock! !

CUChange subclass: #CUObjectChange
	instanceVariableNames: 'original previous working'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Trans'!

!CUObjectChange class methodsFor: 'instance creation' stamp: 'lr 6/8/2007 16:59'!
on: anObject
	^ self basicNew initializeOn: anObject! !

!CUObjectChange methodsFor: 'actions' stamp: 'lr 2/23/2009 15:51'!
apply
	original copyFrom: working! !

!CUObjectChange methodsFor: 'testing' stamp: 'lr 2/23/2009 16:15'!
hasChanged
	1 to: working class instSize do: [ :index |
		(working instVarAt: index) == (previous instVarAt: index)
			ifFalse: [ ^ true ] ].
	1 to: working basicSize do: [ :index |
		(working basicAt: index) == (previous basicAt: index)
			ifFalse: [ ^ true ] ].
	^ false! !

!CUObjectChange methodsFor: 'testing' stamp: 'lr 2/23/2009 16:14'!
hasConflict
	1 to: original class instSize do: [ :index |
		(original instVarAt: index) == (previous instVarAt: index)
			ifFalse: [ ^ true ] ].
	1 to: original basicSize do: [ :index |
		(original basicAt: index) == (previous basicAt: index)
			ifFalse: [ ^ true ] ].
	^ false! !

!CUObjectChange methodsFor: 'initialization' stamp: 'lr 2/23/2009 15:51'!
initializeOn: anObject
	original := anObject.
	working := original shallowCopy.
	previous := working shallowCopy! !

!CUObjectChange methodsFor: 'accessing' stamp: 'lr 6/8/2007 17:00'!
original
	^ original! !

!CUObjectChange methodsFor: 'accessing' stamp: 'lr 6/8/2007 17:00'!
previous
	^ previous! !

!CUObjectChange methodsFor: 'printing' stamp: 'lr 6/8/2007 17:01'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' ['; print: self original; nextPut: $]! !

!CUObjectChange methodsFor: 'accessing' stamp: 'lr 6/8/2007 17:00'!
working
	^ working! !

Object subclass: #CUTransaction
	instanceVariableNames: 'context changes objectChanges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Trans'!

!CUTransaction methodsFor: 'private' stamp: 'lr 2/23/2009 16:41'!
abort
	"Abort a transaction."
	
	context := changes := objectChanges := nil! !

!CUTransaction methodsFor: 'public' stamp: 'lr 2/23/2009 15:09'!
abort: aValue
	"Abort a transaction."

	thisContext swapSender: context.
	self abort.
	^ aValue! !

!CUTransaction methodsFor: 'accessing' stamp: 'lr 2/23/2009 15:11'!
addChange: aChange
	^ changes add: aChange! !

!CUTransaction methodsFor: 'public' stamp: 'lr 2/23/2009 13:54'!
atomic: aBlock
	"Start a transaction with aBlock."

	^ self atomic: aBlock ifConflict: [ self signalConflict ]! !

!CUTransaction methodsFor: 'public' stamp: 'lr 2/23/2009 16:42'!
atomic: aBlock ifConflict: aConflictBlock
	"Evaluate aBLock within a new transaction, unless we are already in an existing transactional context. Evaluate aConflictBlock if the transaction conflicts with concurrent edits."

	| result |
	context := thisContext sender.
	self begin.
	[ result := aBlock
		on: CUTransactionCurrent
		do: [ :err | err resume: self ] ]
			ifCurtailed: [ self abort ].
	self commitIfConflict: aConflictBlock.
	^ result! !

!CUTransaction methodsFor: 'private' stamp: 'lr 2/23/2009 16:41'!
begin
	"Start a transaction. If this is a nested transaction copy the parent changes into our own context."
	
	changes := OrderedCollection new.
	objectChanges := IdentityDictionary new! !

!CUTransaction methodsFor: 'accessing' stamp: 'lr 2/23/2009 15:11'!
changeFor: anObject 
	^ objectChanges 
		at: anObject
		ifAbsentPut: [ self addChange: (CUObjectChange on: anObject) ]! !

!CUTransaction methodsFor: 'accessing' stamp: 'lr 2/23/2009 15:11'!
changes
	"Answer an ordered collection of unique changes."

	^ changes! !

!CUTransaction methodsFor: 'public' stamp: 'lr 2/23/2009 13:58'!
checkpoint
	"Checkpoint a transaction."

	self commit; begin! !

!CUTransaction methodsFor: 'private' stamp: 'lr 2/23/2009 15:10'!
commit
	"Commit a transaction."

	self commitIfConflict: [ self signalConflict ]! !

!CUTransaction methodsFor: 'private' stamp: 'lr 2/23/2009 16:40'!
commitIfConflict: aBlock
	"Commit a transaction atomically."
	
	[	changes do: [ :each |
			each hasConflict
				ifTrue: [ ^ aBlock value ] ].
		changes do: [ :each |
			each hasChanged
				ifTrue: [ each apply ] ] ]
		valueUnpreemptively! !

!CUTransaction methodsFor: 'accessing' stamp: 'lr 2/23/2009 15:11'!
objectChanges
	^ objectChanges! !

!CUTransaction methodsFor: 'public' stamp: 'lr 2/23/2009 16:13'!
retry: aBlock
	"Unconditionally retry to evaluate aBlock until there are no conflict."

	^ self atomic: aBlock ifConflict: [ self retry: aBlock ]! !

!CUTransaction methodsFor: 'private' stamp: 'lr 2/23/2009 16:43'!
signalConflict
	^ CUTransactionConflict new
		transaction: self;
		signal! !

!Object methodsFor: '*cutie-helvetia-trans' stamp: 'lr 2/23/2009 15:56'!
atomicInstVarAt: anInteger
	^ self instVarAt: anInteger! !

!Object methodsFor: '*cutie-helvetia-trans' stamp: 'lr 2/23/2009 15:56'!
atomicInstVarAt: anInteger put: anObject
	^ self instVarAt: anInteger put: anObject! !

Error subclass: #CUTransactionConflict
	instanceVariableNames: 'transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Trans'!

!CUTransactionConflict methodsFor: 'accessing' stamp: 'lr 5/25/2007 09:04'!
transaction
	^ transaction! !

!CUTransactionConflict methodsFor: 'accessing' stamp: 'lr 5/25/2007 09:04'!
transaction: aTransaction
	transaction := aTransaction! !
